;*****************************************
;* 
;* 
;* 
;*****************************************


BANK_00   EQU  $00
BANK_01   EQU  $01
BANK_02   EQU  $02
BANK_03   EQU  $03
BANK_04   EQU  $04
BANK_05   EQU  $05
BANK_06   EQU  $06
BANK_07   EQU  $07
BANK_08   EQU  $08
BANK_09   EQU  $09
BANK_10   EQU  $0A
BANK_11   EQU  $0B
BANK_12   EQU  $0C
BANK_13   EQU  $0D
BANK_14   EQU  $0E
BANK_15   EQU  $0F
BANK_16   EQU  $10
BANK_17   EQU  $11
BANK_18   EQU  $12
BANK_19   EQU  $13
BANK_20   EQU  $14
BANK_21   EQU  $15
BANK_22   EQU  $16
BANK_23   EQU  $17
BANK_24   EQU  $18
BANK_25   EQU  $19


SETOBJ: MACRO
            DW \1
            DB \2
            DB \3
        ENDM
        
PUSHALL: MACRO
            PUSH HL
            PUSH DE
            PUSH BC
            PUSH AF
        ENDM

POPALL: MACRO
            POP AF
            POP BC
            POP DE
            POP HL
        ENDM

;*****************************************
;* 
;*****************************************
STATF_LYC     EQU  %01000000 ; LYCEQULY Coincidence (Selectable)
STATF_MODE10  EQU  %00100000 ; Mode 10
STATF_MODE01  EQU  %00010000 ; Mode 01 (V-Blank)
STATF_MODE00  EQU  %00001000 ; Mode 00 (H-Blank)
STATF_LYCF    EQU  %00000100 ; Coincidence Flag
STATF_HB      EQU  %00000000 ; H-Blank
STATF_VB      EQU  %00000001 ; V-Blank
STATF_OAM     EQU  %00000010 ; OAM-RAM is used by system
STATF_LCD     EQU  %00000011 ; Both OAM and VRAM used by system
STATF_BUSY    EQU  %00000010 ; When set, VRAM access is unsafe


WaitForVRAM:   MACRO
                    ldh     a,[R_STAT]  ; <---+
                    and     STATF_BUSY  ;     |
                    jr      nz,@-4      ; ----+
                ENDM

;*****************************************
;* 
;*****************************************




scrFunc_00: MACRO
                DB $00
            ENDM
;??????            
scrFunc_01: MACRO
                DB $01
            ENDM
            
scrFunc_Delay: MACRO
                DB $02
                DB \1
               ENDM

scrFunc_03: MACRO
                DB $03
                DW \1
            ENDM

scrFunc_State: MACRO
                DB $04
                DW \1
               ENDM

scrFunc_05: MACRO
                DB $05                                
                DB \1                                
                DW \2                                
            ENDM

scrFunc_Call: MACRO
                DB $06                                
                DW \1                                
              ENDM

scrFunc_GotoSrc: MACRO
                    DB $07                                
                    DW \1                                
                 ENDM

scrFunc_08: MACRO
                DB $08                                
                DW \1                                
            ENDM

scrFunc_Ret: MACRO
                DB $09                               
            ENDM

scrFunc_0A: MACRO
                DB $0A                                
                DW \1                                
            ENDM

scrFunc_0B: MACRO
                DB $0B                               
            ENDM

scrFunc_0C: MACRO
                DB $0C                               
            ENDM
; 
; 1 -  
; 2 - (SCR) 
scrFunc_0D: MACRO       
                DB $0D                                
                DB \1                                
                DW \2                                
            ENDM

scrFunc_0E: MACRO
                DB $0E                                
                DB \1                                
                DW \2                                
            ENDM

scrFunc_0F: MACRO
                DB $0F                                
                DW \1                                
            ENDM



scrFunc_IF_NZ: MACRO
                    DB $0F
                    DW \1                                
                ENDM

scrFunc_10: MACRO
                DB $10
                DW \1                                
            ENDM

scrFunc_11: MACRO
                DB $11                                
                DB \1                                
                DB \2
                DW \3 
            ENDM

scrFunc_12: MACRO
                DB $12                               
            ENDM

scrFunc_13: MACRO
                DB $13
                DW \1                                
            ENDM


;;1  CHAR                             
;;2  SIZE                             
;;3  ADDRES                              
scrFunc_MemSet: MACRO
                    DB $14                                
                    DB \1                                
                    DB \2
                    DW \3 
                ENDM


scrFunc_PlaySnd: MACRO
                    DB $16
                    DB \1                                
                 ENDM

scrFunc_17: MACRO
                DB $17                               
            ENDM

scrFunc_18: MACRO
                DB $18                               
            ENDM

scrFunc_1A: MACRO
                DB $1A                               
            ENDM

scrFunc_1B: MACRO
                DB $1B                               
            ENDM


scrFunc_1E: MACRO
                DB $1E
                DB \1                                
            ENDM

scrFunc_1F: MACRO
                DB $1F
                DB \1                                
            ENDM

scrFunc_21: MACRO
                DB $21                               
            ENDM

scrFunc_22: MACRO
                DB $22                               
            ENDM

scrFunc_25: MACRO
                DB $25                               
            ENDM

scrFunc_26: MACRO
                DB $26                               
            ENDM

scrFunc_27: MACRO
                DB $27                                
                DB \1                                
                DB \2                                
            ENDM

scrFunc_28: MACRO
                DB $28                                
                DB \1                                
                DB \2                                
            ENDM

scrFunc_29: MACRO
                DB $29
                DB \1                                
            ENDM
            
scrFunc_2A: MACRO
                DB $2A
                DB \1                                
            ENDM

scrFunc_2B: MACRO
                DB $2B
                DB \1                                
            ENDM
            
scrFunc_2C: MACRO
                DB $2C
                DB \1                                
            ENDM

scrFunc_2E: MACRO
                DB $2E                               
            ENDM

scrFunc_30: MACRO
                DB $30                               
            ENDM

scrFunc_34: MACRO
                DB $34
                ;DW \1 
                DB \1                                
                DB \2                                
            ENDM

scrFunc_36: MACRO
                DB $36
                DB \1                                
            ENDM

scrFunc_37: MACRO
                DB $37                                
                DB \1                                
                DB \2                                
                DB \3                                
                DW \4                               
            ENDM

scrFunc_Draw: MACRO
                DB $39                                
                DW \1                                
                DW \2                                
              ENDM

scrFunc_DrawA: MACRO
                DB $4B                                
                DW \1                                
                DW \2                                
              ENDM

scrFunc_ClearScreen: MACRO
                        DB $4C                                
                     ENDM

scrFunc_3B: MACRO
                DB $3B
                DW \1                                
            ENDM

scrFunc_3E: MACRO
                DB $3E
                DB \1                                
            ENDM
                                      
scrFunc_48: MACRO
                DB $48                                
            ENDM
            
scrFunc_4A: MACRO
                DB $4A                                
                DB \1                                
                DB \2                                
            ENDM
            
            
FUNC_00   EQU  $00
FUNC_01   EQU  $01
FUNC_DELAY   EQU  $02
FUNC_03   EQU  $03
FUNC_STATE   EQU  $04
FUNC_05   EQU  $05
FUNC_CALL   EQU  $06
FUNC_CALL_SRC   EQU  $07
FUNC_08   EQU  $08
FUNC_RET   EQU  $09
FUNC_0A   EQU  $0A
FUNC_0B   EQU  $0B
FUNC_0C   EQU  $0C
FUNC_0D   EQU  $0D
FUNC_0E   EQU  $0E
FUNC_IF_NZ   EQU  $0F
FUNC_10   EQU  $10
FUNC_11   EQU  $11
FUNC_12   EQU  $12
FUNC_13   EQU  $13
FUNC_SETMEM   EQU  $14
FUNC_PLAY_SND   EQU  $16
FUNC_17   EQU  $17
FUNC_18   EQU  $18
FUNC_1A   EQU  $1A
FUNC_1B   EQU  $1B
FUNC_1E   EQU  $1E
FUNC_1F   EQU  $1F
FUNC_21   EQU  $21
FUNC_22   EQU  $22
FUNC_25   EQU  $25
FUNC_26   EQU  $26
FUNC_27   EQU  $27
FUNC_28   EQU  $28
FUNC_29   EQU  $29
FUNC_2A   EQU  $2A
FUNC_2B   EQU  $2B
FUNC_2C   EQU  $2C
FUNC_2E   EQU  $2E
FUNC_30   EQU  $30
FUNC_34   EQU  $34
FUNC_36   EQU  $36
FUNC_37   EQU  $37
FUNC_DRAW   EQU  $39
FUNC_3B   EQU  $3B
FUNC_3E   EQU  $3E
FUNC_48   EQU  $48
FUNC_4A   EQU  $4A




R_P1  	    EQU $FF00   ; P1/JOYP JOYPAD (R/W)    
R_SB  	    EQU $FF01   ; SERIAL TRANSFER DATA (R/W)    
R_SC  	    EQU $FF02   ; SERIAL TRANSFER CONTROL (R/W)
R_DIV 	    EQU $FF04   ; DIVIDER REGISTER (R/W)
R_TIMA	    EQU $FF05   ; TIMER COUNTER (R/W)  
R_TMA 	    EQU $FF06   ; TIMER MODULO (R/W)
R_TAC 	    EQU $FF07   ; TIMER CONTROL (R/W)
R_IF  	    EQU $FF0F   ; INTERRUPT FLAG (R/W)

R_NR10	    EQU $FF10   ; CHANNEL 1 SWEEP REGISTER (R/W)
R_NR11	    EQU $FF11   ; CHANNEL 1 SOUND LENGTH/WAVE PATTERN DUTY (R/W)
R_NR12	    EQU $FF12   ; CHANNEL 1 VOLUME ENVELOPE (R/W)
R_NR13	    EQU $FF13   ; CHANNEL 1 FREQUENCY LO (WRITE ONLY)
R_NR14	    EQU $FF14   ; CHANNEL 1 FREQUENCY HI (R/W)
R_NR21	    EQU $FF16   ; CHANNEL 2 SOUND LENGTH/WAVE PATTERN DUTY (R/W)
R_NR22	    EQU $FF17   ; CHANNEL 2 VOLUME ENVELOPE (R/W)
R_NR23	    EQU $FF18   ; CHANNEL 2 FREQUENCY LO DATA (W)
R_NR24	    EQU $FF19   ; CHANNEL 2 FREQUENCY HI DATA (R/W)
R_NR30	    EQU $FF1A   ; CHANNEL 3 SOUND ON/OFF (R/W)
R_NR31	    EQU $FF1B   ; CHANNEL 3 SOUND LENGTH
R_NR32	    EQU $FF1C   ; CHANNEL 3 SELECT OUTPUT LEVEL (R/W)
R_NR33	    EQU $FF1D   ; CHANNEL 3 FREQUENCY'S LOWER DATA (W)
R_NR34	    EQU $FF1E   ; CHANNEL 3 FREQUENCY'S HIGHER DATA (R/W)
R_NR41	    EQU $FF20   ; CHANNEL 4 SOUND LENGTH (R/W)
R_NR42	    EQU $FF21   ; CHANNEL 4 VOLUME ENVELOPE (R/W)
R_NR43	    EQU $FF22   ; CHANNEL 4 POLYNOMIAL COUNTER (R/W)
R_NR44	    EQU $FF23   ; CHANNEL 4 COUNTER/CONSECUTIVE; INITAL (R/W)
R_NR50	    EQU $FF24   ; CHANNEL CONTROL / ON-OFF / VOLUME (R/W)
R_NR51	    EQU $FF25   ; SELECTION OF SOUND OUTPUT TERMINAL (R/W)
R_NR52	    EQU $FF26   ; SOUND ON/OFF
R_WAVE1	    EQU $FF30   ; WAVE PATTERN RAM
R_WAVE2	    EQU $FF31   ; WAVE PATTERN RAM
R_WAVE3	    EQU $FF32   ; WAVE PATTERN RAM
R_WAVE4	    EQU $FF33   ; WAVE PATTERN RAM
R_WAVE5	    EQU $FF34   ; WAVE PATTERN RAM
R_WAVE6	    EQU $FF35   ; WAVE PATTERN RAM
R_WAVE7	    EQU $FF36   ; WAVE PATTERN RAM
R_WAVE8	    EQU $FF37   ; WAVE PATTERN RAM
R_WAVE9	    EQU $FF38   ; WAVE PATTERN RAM
R_WAVE10 	EQU $FF39   ; WAVE PATTERN RAM
R_WAVE11	EQU $FF3A   ; WAVE PATTERN RAM
R_WAVE12	EQU $FF3B   ; WAVE PATTERN RAM
R_WAVE13	EQU $FF3C   ; WAVE PATTERN RAM
R_WAVE14	EQU $FF3D   ; WAVE PATTERN RAM
R_WAVE15	EQU $FF3E   ; WAVE PATTERN RAM
R_WAVE16	EQU $FF3F   ; WAVE PATTERN RAM

R_LCDC	    EQU $FF40   ; LCD CONTROL (R/W)
R_STAT	    EQU $FF41   ; LCDC STATUS (R/W)
R_SCY 	    EQU $FF42   ; SCROLL Y (R/W)
R_SCX 	    EQU $FF43   ; SCROLL X (R/W)
R_LY  	    EQU $FF44   ; LCDC Y-COORDINATE (R)
R_LYC 	    EQU $FF45   ; LY COMPARE (R/W)
R_DMA 	    EQU $FF46   ; DMA TRANSFER AND START ADDRESS (W)
R_BGP 	    EQU $FF47   ; BG PALETTE DATA (R/W) - NON CGB MODE ONLY
R_OBP0	    EQU $FF48   ; OBJECT PALETTE 0 DATA (R/W) - NON CGB MODE ONLY
R_OBP1	    EQU $FF49   ; OBJECT PALETTE 1 DATA (R/W) - NON CGB MODE ONLY
R_WY  	    EQU $FF4A   ; WINDOW Y POSITION (R/W)
R_WX  	    EQU $FF4B   ; WINDOW X POSITION MINUS 7 (R/W)
R_KEY1	    EQU $FF4D   ; CGB MODE ONLY - PREPARE SPEED SWITCH
R_VBK 	    EQU $FF4F   ; CGB MODE ONLY - VRAM BANK
R_HDMA1	    EQU $FF51   ; CGB MODE ONLY - NEW DMA SOURCE, HIGH 
R_HDMA2	    EQU $FF52   ; CGB MODE ONLY - NEW DMA SOURCE, LOW 
R_HDMA3	    EQU $FF53   ; CGB MODE ONLY - NEW DMA DESTINATION, HIGH
R_HDMA4	    EQU $FF54   ; CGB MODE ONLY - NEW DMA DESTINATION, LOW
R_HDMA5	    EQU $FF55   ; CGB MODE ONLY - NEW DMA LENGTH/MODE/START 
R_RP  	    EQU $FF56   ; CGB MODE ONLY - INFRARED COMMUNICATIONS PORT    
R_BCPS	    EQU $FF68   ; CGB MODE ONLY - BACKGROUND PALETTE INDEX
R_BCPD	    EQU $FF69   ; CGB MODE ONLY - BACKGROUND PALETTE DATA
R_OCPS	    EQU $FF6A   ; CGB MODE ONLY - SPRITE PALETTE INDEX
R_OCPD	    EQU $FF6B   ; CGB MODE ONLY - SPRITE PALETTE DATA
R_6C  	    EQU $FF6C   ; UNDOCUMENTED (FEH) - BIT 0 (READ/WRITE) - CGB MODE ONLY
R_SVBK	    EQU $FF70   ; CGB MODE ONLY - WRAM BANK
R_72 	    EQU $FF72   ; UNDOCUMENTED (00H) - BIT 0-7 (READ/WRITE)
R_73 	    EQU $FF73   ; UNDOCUMENTED (00H) - BIT 0-7 (READ/WRITE)
R_74 	    EQU $FF74   ; UNDOCUMENTED (00H) - BIT 0-7 (READ/WRITE) - CGB MODE ONLY
R_75 	    EQU $FF75   ; UNDOCUMENTED (8FH) - BIT 4-6 (READ/WRITE)
R_76 	    EQU $FF76   ; UNDOCUMENTED (00H) - ALWAYS 00H (READ ONLY)
R_77 	    EQU $FF77   ; UNDOCUMENTED (00H) - ALWAYS 00H (READ ONLY)
R_IE  	    EQU $FFFF   ; INTERRUPT ENABLE (R/W)




CHR8000   EQU  $8000 ; Character Data 
CHR8800   EQU  $8800 ; Character Data 
SCRN9800  EQU  $9800 ; Screen Display Data 
SCRN9C00  EQU  $9C00 ; Screen Display Data 







INCLUDE			"MEMORY.ASM"
INCLUDE			"BANK_00_1.ASM"
INCLUDE			"BANK_00_2.ASM"
INCLUDE			"BANK_00_3.ASM"


INCLUDE			"BANK_01.ASM"
INCLUDE			"BANK_01_OBJECT_BERMUDA.ASM"
INCLUDE			"BANK_01_OBJECT_EGYPT.ASM"
INCLUDE			"BANK_01_OBJECT_LAST.ASM"
INCLUDE			"BANK_01_OBJECT_MU.ASM"
INCLUDE			"BANK_01_OBJECT_NIAGARA.ASM"
INCLUDE			"BANK_01_OBJECT_SCOTLAND.ASM"
INCLUDE			"BANK_01_OBJECT_UNDERGROUND.ASM"
INCLUDE			"BANK_02.ASM"
INCLUDE			"BANK_03.ASM"
INCLUDE			"BANK_04.ASM"
INCLUDE			"BANK_05.ASM"
INCLUDE			"BANK_06.ASM"
INCLUDE			"BANK_07.ASM"
INCLUDE			"BANK_08.ASM"
INCLUDE			"BANK_09.ASM"
INCLUDE			"BANK_10.ASM"
INCLUDE			"BANK_11.ASM"
INCLUDE			"BANK_12.ASM"
INCLUDE			"BANK_13.ASM"
INCLUDE			"BANK_14_LEVELS.ASM"
INCLUDE			"BANK_14_LEVEL_BERMUDA.ASM"
INCLUDE			"BANK_14_LEVEL_EGYPT.ASM"
INCLUDE			"BANK_14_LEVEL_LAST.ASM"
INCLUDE			"BANK_14_LEVEL_MU.ASM"
INCLUDE			"BANK_14_LEVEL_NIAGARA.ASM"
INCLUDE			"BANK_14_LEVEL_SCOTLAND.ASM"
INCLUDE			"BANK_14_LEVEL_UNDERGROUND.ASM"

INCLUDE			"BANK_15.ASM"
INCLUDE			"BANK_16.ASM"
INCLUDE			"BANK_17_NIAGARA.ASM"
INCLUDE			"BANK_18_BERMUDA.ASM"
INCLUDE			"BANK_19_EGYPT.ASM"
INCLUDE			"BANK_20_MU.ASM"
INCLUDE			"BANK_21_SCOTLAND.ASM"
INCLUDE			"BANK_22_UNDERGROUND.ASM"
INCLUDE			"BANK_23_LAST.ASM"
INCLUDE			"BANK_24.ASM"
INCLUDE			"BANK_25.ASM"
















