SECTION "MY3", HOME

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;*****************************************
;* 
;*****************************************
Data_0_0585:
	DW $8000 ;tiles 00-3f
	DW $8400 ;tiles 40-7f
	DW $8800 ;tiles 80-bf
	DW $8C00 ;tiles c0-ff
	DW $9000 ;tiles 00-3f
	DW $9400 ;tiles 40-7f

;*****************************************
;* GetTileSetAddr
;* B  <  
;* HL > 
;* ;;;A  > 
;* ;;;B  >  tileset   
;*****************************************
GetTileSetAddr:                             ;
	push DE
    
    ld A,B                               ; B( )8E
	swap A                               ; E8       A.
    and $0F                              ; 8  
 	
    ldh [MEM_CURRENT_BANK],A
    ld [$2000],A                         ;  
   
    ld A,B                               ; 
	and $0F                              ; 00001111
	ld HL,$4000                          ;      $4000
	rst $20                              ; 
    ld H,D                               ; 
	ld L,E                               ; HL =  tiles
    
    pop DE
	ret                                  ; 


;*****************************************
;* SetFullTiles
;* HL <-    6 
;*****************************************
SetFullTiles:                            ;   
    ld C,$00                             ; 
.L_000575:                               ;   
	push BC                              ; 
	push HL                              ; 
	ld B,[HL]                            ; 
	call SetTiles ;04:0591          ; 
	pop HL                               ; 
	pop BC                               ; 
	inc HL                               ; 
	inc C                                ; 
	ld A,$06                             ;
	cp C                                 ; 
	jr NZ,.L_000575                      ;  6   
	ret                                  ; 

;*****************************************
;* SetTiles
;* C <-   tileset
;* B <-   
;* bbbbnnnn
;* bbbb -      tiles
;* nnnn -       tiles
;*****************************************
SetTiles:                                ;  
	ld A,[MEM_CURRENT_BANK]              ; A = CURRENT_BANK
	push AF                              ; 

	ld A,C                               ; 
	ld E,A                               ; 
	ld D,$00                             ; DE = $00nn  nn -   tileset
	ld HL,$C9FF                          ;
	add HL,DE                            ; HL = $C9FF+DE 
	ld A,B                               ;
	ld [HL],A                            ; [HL] = B( )

    ld A,C                               ; 
	ld HL,Data_0_0585                    ; 
	rst $20                              ; DE=     Data_0_0585+C*2
	
    call GetTileSetAddr                 ; HL=$C100  tiles
    
	ld B, $08                            ; 
.L_0005AD:                               ;        LCD
	push BC                              ; 
        ; ld B, $40                            ; 
        ; ld A,D                               ; 
        ; ldh [$FF96],A                        ; 
        ; ld A,E                               ; 
        ; ldh [$FF97],A                        ; [$FF96] = DE
        push DE                              ; 
            ld A,[MEM_VBK_BANK]                                
            ldh [R_VBK],A 
            ;call F_Addr_00046C
            LD B,0;
            LD C,$40
            call MemCopyVRAM
            ld A,0                                
            ldh [R_VBK],A 
        pop DE                               ; 
        
        ld A,E                               ; 
        add A,$40                            ; 
        ld E,A                               ; 
        ld A,D                               ; 
        adc A,$00                            ; 
        ld D,A                               ; 
        
        ; ld B, $40                            ; 
        ; ld A,D                               ; 
        ; ldh [$FF96],A                        ;
        ; ld A,E                               ; 
        ; ldh [$FF97],A                        ; 
        push DE                              ; 
            ld A,[MEM_VBK_BANK]                                
            ldh [R_VBK],A 
            ;call F_Addr_00046C
            LD B,0;
            LD C,$40
            call MemCopyVRAM
            ld A,0                                
            ldh [R_VBK],A 
        pop DE                               ; 
        ld A,E                               ;
        add A,$40                            ; 
        ld E,A                               ; 
        ld A,D                               ; 
        adc A,$00                            ; 
        ld D,A                               ;
	pop BC                               ; 
	dec B                                ; 
	jr NZ,.L_0005AD                      ; 
    
	pop AF                               ;
	ldh [MEM_CURRENT_BANK],A             ;    
	ld [$2000],A                         ; 
    
	ret                                  ; 

;*****************************************
;* SETUP TILE ;;;DB $A1,$11,$0E,$02,$00 ;
;*****************************************
SetupTile:
    ld A,[HL+]                            
	and A                                 
	ret Z                                 
	ld [$C9FB],A ;05:C9FB                 
.L_0005F3:
        ld A,[MEM_CURRENT_BANK]              ; A = CURRENT_BANK
        push AF                              ; 
    
        ld A,[HL+]                            
        ld B,A                ;   tileset                
        ld A,[HL+]                            
        ld [$C9FD],A ;05:C9FD ;     tileset                
        ld A,[HL+]                            
        ld [$C9FC],A ;05:C9FC ;                 
        ld A,[HL+]                            
        ld C,A                ;  - Data_0_0585  
        swap A                  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        and $01
        ld [MEM_VBK_BANK],A     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        ldh [R_VBK],A
        ld A,C                  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        and $0f
        ld C,A
        
        ld A,[HL+]                            
        ld [$C9FE],A ;05:C9FE ;     tilesets(Data_0_0585)            
        push HL      
        
        ld A,C                                
        ld HL,Data_0_0585                           
        rst $20             ; DE    

        call GetTileSetAddr                 ; HL=$C100  tiles

        ld A,[$C9FD] ;05:C9FD                 
        call F_Addr_0005DD ;05:05DD             
        add HL,BC                             
        ld A,[$C9FE] ;05:C9FE                 
        call F_Addr_0005DD ;05:05DD             
        ld A,E                                
        add A,C                               
        ld E,A                                
        ld A,D                                
        adc A,B                               
        ld D,A                                
.L_000627:
            ; ld B, $10                             
            ; ld A,D                                
            ; ldh [$FF96],A                     
            ; ld A,E                                
            ; ldh [$FF97],A                     
            push DE 
             
            ld A,[MEM_VBK_BANK]     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
            ldh [R_VBK],A
            ;;;;;;;call F_Addr_00046C ;05:046C 
            
            LD B,0;
            LD C,$10
            call MemCopyVRAM
            
            xor A,A
            ldh [R_VBK],A
            
            pop DE                                
            ld A,E                                
            add A,$10                             
            ld E,A                                
            ld A,D                                
            adc A,$00                             
            ld D,A                                
        ld A,[$C9FC] ;05:C9FC                 
        dec A                                 
        ld [$C9FC],A ;05:C9FC                 
        jr NZ,.L_000627   
        
        pop HL  

	pop AF                               ;
	ldh [MEM_CURRENT_BANK],A             ;    
	ld [$2000],A                         ; 

    ld A,[$C9FB] ;05:C9FB                 
    dec A                                 
	ld [$C9FB],A ;05:C9FB                 
	jr NZ,.L_0005F3
    
    xor A               ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ld [MEM_VBK_BANK],A ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ldh [R_VBK],A
	ret                                   

;*****************************************
;* 
;*****************************************
F_Addr_0005DD:
	ld C,A                                
	xor A                                 
	sla C                                 
	rla                                   
	sla C                                 
	rla                                   
	sla C                                 
	rla                                   
	sla C                                 
	rla                                   
	ld B,A                                
	ret                                   



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;*****************************************
;*  .
;*    
;*****************************************
D_DialogWidth:
	DB $10                                ; Dialog_5_70F8
	DB $0C                                ; Dialog_5_710E
	DB $11                                ; Dialog_5_7164
	DB $11                                ; Dialog_5_71C6

;*****************************************
;*  .
;*   .
;*****************************************
D_DialogPos:
	DW $9982                              ; Dialog_5_70F8
	DW $99C4                              ; Dialog_5_710E
	DW $9D02                              ; Dialog_5_7164
	DW $9962                              ; Dialog_5_71C6
    
;*****************************************
;* 
;*****************************************
PrintDialog:
	ld A,BANK_02                              
	ld [$2000],A ;05:2000                 
    
    ld A,[$C934]                          
	ld HL,D_DialogWidth                     
	rst $18                               
	ld [$C5A1],A                          
	ld A,$04                              
	ld [$C5A2],A                          
	ld A,[$C934]                          
	ld HL,D_DialogPos                     
	rst $20                               
	ld A,E                                
	ldh [$FF97],A                         
	ld A,D                                
	ldh [$FF96],A 

	ld HL,ENG_Dialogues                
    ; ld A,[LANGUAGE] 
	; cp $01  
	; jr NZ,.L_ENG
	; ld HL,RUS_Dialogues                
; .L_ENG:	
	ld A,[$C934]                          
    rst $20                               
	ld L,E                                
	ld H,D                                
	ld A,[$C935]                          
	rst $20                               
	call PrintText                    
	ld DE,$C936                           
	ld C,$04 

	ldh A,[MEM_CURRENT_BANK]                             
	ld [$2000],A ;05:2000               
	call F_Addr_00081B
    ret    

;*****************************************
;* 
;*****************************************
PrintText:
	ld HL,$C936                           ;
.L_0171E7:                                ;  
	ld A,[DE]                             ;
	inc DE                                ;
	cp $FF                                ;  
	jr Z,.L_01724D                        ;
	cp $FD                                ;  
	jr Z,.L_017200                        ;
	cp $FC                                ;   
	jr Z,.L_017234                        ;
	cp $F0                                ; 
	jr NC,.L_0171FD                       ;     ???
    
    push HL
    ld HL,ASCI_TABLE
    rst $10
    ld A,[HL]
    pop HL
    
.L_0171FD:                                ;  
	ld [HL+],A                            ;
	jr .L_0171E7                          ;
    
.L_017200:                                ;      
	push DE                               ;
	ld A,[$C91B] ;05:C91B                 ;
	ld D,A                                ;
	ld B, $FF                             ;
.L_017207:                                ;  
	inc B                                 ;
	ld A,D                                ;
	ld E,A                                ;
	sub $64                               ;
	ld D,A                                ;
	jr NC,.L_017207                       ;
	ld A,B                                ;
	ld C,A                                ;
	and A                                 ;
	jr Z,.L_017217                        ;
	or $F0                              ;*;
	ld [HL+],A                          ;*;
.L_017217:                                ;  
	ld B, $FF                             ;
.L_017219:                                ;  
	inc B                                 ;
	ld A,E                                ;
	ld D,A                                ;
	sub $0A                               ;
	ld E,A                                ;
	jr NC,.L_017219                       ;
	ld A,C                                ;
	and A                                 ;
	jr NZ,.L_017229                       ;
	ld A,B                                ;
	and A                                 ;
	jr Z,.L_01722D                        ;
.L_017229:                                ;      
	ld A,B                                ;
	or $F0                                ;
	ld [HL+],A                            ;
.L_01722D:                                ;          
	ld A,D                                ;
	or $F0                                ;
	ld [HL+],A                            ;
	pop DE                                ;
	jr .L_0171E7                          ;
    
.L_017234:                                ;          
	push HL                               ;
	ld A,[$C921] ;05:C921                 ;
	ld B, $08                             ;
	ld C,$00                              ;
.L_01723C:                                ;  
	rrca                                  ;
	jr NC,.L_017240                       ;
	inc C                                 ;
.L_017240:                                ;  
	dec B                                 ;
	jr NZ,.L_01723C                       ;
	ld A,C                                ;
	inc A                                 ;
	ld HL,D_0008DE ;$08DE                 ;
	rst $18                               ;
	pop HL                                ;
	ld [HL+],A                            ;
	jr .L_0171E7                          ;
.L_01724D:                                ;   
	ld [HL],A                             ;
	ret                                   ;
    
ASCI_TABLE:
    ;  0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 0
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 1
    DB $00,$3E,$30,$00,$00,$00,$00,$3D,$00,$00,$00,$00,$37,$3B,$3C,$00 ; 2
    DB $F0,$F1,$F2,$F3,$F4,$F5,$F6,$F7,$F8,$F9,$00,$00,$00,$00,$00,$3F ; 3
    DB $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F ; 4
    DB $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$00,$00,$00,$00,$00 ; 5
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 6
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 7
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 8
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 9
    DB $00,$00,$00,$00,$00,$00,$00,$2B,$21,$00,$00,$00,$00,$00,$00,$00 ; A
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; B
    DB $01,$20,$02,$26,$28,$05,$22,$29,$24,$25,$0B,$27,$0D,$08,$0F,$2B ; C
    DB $10,$03,$14,$2A,$31,$18,$33,$34,$35,$36,$23,$1B,$30,$32,$2C,$2D ; D
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; E
    DB $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; F


;*****************************************
;* 
;*****************************************
F_Addr_00081B:
	ld A,$FF                              
	ld [$C5A9],A ;05:C5A9                 
	ld HL,$C5A3                           
	ld [HL],C                             
	inc HL                                
	ld [HL],C                             
	ld HL,$C5A5                           
	ldh A,[$FF97]                     
	ld [HL+],A                            
	ldh A,[$FF96]                     
	ld [HL+],A                            
	ld A,E                                
	ld [HL+],A                            
	ld A,D                                
	ld [HL+],A                            
	ld HL,$C5AB                           
	ld A,[$C5A1] ;05:C5A1                 
	or $80                                
	ld [HL+],A                            
	ld A,[$C5A2] ;05:C5A2                 
	or $80                                
	ld [HL+],A                            
	ld A,[$C5CF] ;05:C5CF                 
	ld [HL],A                             
	ld HL,$C5AB  
    
	call F_Addr_0004D6 ;     
	;;;;;;;call DrawPic2 
    
    xor A                                 
	ld [$C5AA],A ;05:C5AA                 
	ld [$C5A9],A ;05:C5A9                 
	ret                                   


















